package com.example.ynair_000.myfirstandroidjava;

import android.graphics.Color;
import android.graphics.Typeface;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        // ===== 型とリテラル =====
        String hello = "Hello, World!";
        int intValue = 12345;
        long longValue = 12345L;
        double doubleValue = 12.345;
        float floatValue = 12.345F;
        boolean booleanValue = true;

        Log.d("MainActivity", hello);
        Log.d("MainActivity", "" + intValue);
        Log.d("MainActivity", "" + longValue);
        Log.d("MainActivity", "" + doubleValue);
        Log.d("MainActivity", "" + floatValue);
        Log.d("MainActivity", "" + booleanValue);

        // ===== 演算子で式を作る =====
        int n1 = 1;
        int n2 = 1;
        int n3 = n1 + n2;
        // n3は2
        String s1 = "1";
        String s2 = "1";
        String s3 = s1 + s2;
        // s3は"11"

        // ===== キャストで型を変換する（拡大変換） =====
        // int => long
        int intValue2 = 123; // 確実にlong型より狭い値
        long longValue2 = (int) intValue2; // 代入できる
        long longValue3 = intValue2; // この書き方でもよい
        // float => double
        float floatValue2 = 12.345F; // 確実にdouble型より狭い値
        double doubleValue2 = (float) floatValue2; // 代入できる
        double doubleValue3 = floatValue2; // この書き方でもよい
        // int => float
        float floatValue3 = intValue2; // 整数型は小数型に代入できる

        // ===== キャストで型を変換する（拡大変換） =====
        // long => int
        long longValue4 = 123L; // int型に収まるサイズのlong値
        int intValue3 = (int) longValue4; // 代入できる
        // double => float
        double doubleValue4 = 12.345; // float型に収まるサイズのdouble値
        float floatValue4 = (float) doubleValue4; // 代入できる
        // float => int
        int intValue4 = (int) floatValue4; // 小数点以下を切り捨てて代入できる
        // intValue4の値は12

        // ===== メソッドの呼び出し方 =====
        int result = sum(1, 2);

        // ===== 何も返さないメソッド =====
        d("Hello, World!");
        // LogCatには "D/MainActivity: Hello, World!" が出力される

        // ===== 式の中でメソッドを扱う =====
        int result2 = sum(1, 2) + 3;
        // result2は3+3で6になる

        // ===== インスタンスメソッド =====
        String helloWorld = "Hello, World!";
        // "World"を"Android"に置き換えた文字列を作る
        String helloAndroid = helloWorld.replace("World", "Android");
        Log.d("MainActivity", helloAndroid); // "Hello, Android!"

        // ===== TextViewに表示されている文字列を確認する =====
        // レイアウトからTextViewを取り出す
        TextView textViewHello1 = findViewById(R.id.textview_hello);
        // TextViewにセットされている文字を抜き出す
        String text1 = textViewHello1.getText().toString();
        // ログに出力する
        Log.d("MainActivity", text1);

        // ===== TextViewの文字を変えてみよう =====
        // レイアウトからTextViewを取り出す
        TextView textViewHello2 = findViewById(R.id.textview_hello);
        // 画面に表示するデータを用意する
        String text2 = "Hello, Android!";
        // TextViewにデータをセットする
        textViewHello2.setText(text2);

        // ===== 文字の色や太さを変えてみよう =====
        textViewHello2.setTextColor(Color.parseColor("#FF0000"));
        textViewHello2.setTypeface(Typeface.DEFAULT_BOLD);

        // ===== ボタンをタップした際の処理 =====
        Button button = findViewById(R.id.button);
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                EditText editText = findViewById(R.id.editText);
                String text = editText.getText().toString();

                TextView textView = findViewById(R.id.textview_hello);
                textView.setText(text);
            }
        });

        // ===== 条件式とif文 =====
        String yes = isTrue(true);
        String no = isTrue(false);

        // ===== 繰り返しとfor文 =====
        int i = 0;
        while(i < 10) {
            Log.d("MainActivity", "" + i);
            i = i + 1;
        }
        Log.d("MainActivity", "finished!");
    }

    // 足し算をするメソッドを定義する
    private int sum(int a, int b) {
        return a + b; // 足し算の結果を返す
    }

    // ログを出すときに"MainActivity"を省略するためのメソッド
    private void d(String message) {
        Log.d("MainActivity", message);
        // returnは不要
    }

    // if文を使ったメソッド
    private String isTrue(boolean condition) {
        String result;

        if (condition) {
            result = "YES";
        } else {
            result = "NO";
        }

        return result;
    }


}


